<?php

namespace Drupal\tone;

use Drupal\Core\Entity\Display\EntityViewDisplayInterface;
use Drupal\Core\Entity\EntityInterface;

/**
 * Interface for a service responsible to collect extra field information.
 */
interface ToneExtraFieldsInterface {

  /**
   * Returns extra field info as expected by hook_entity_extra_field_info().
   */
  public function getExtraFieldInfo(): array;

  /**
   * Attach tone extra fields for the given entity, view_mode, display.
   */
  public function attach(array $build, EntityInterface $entity, string $view_mode, ?EntityViewDisplayInterface $display = NULL): array;

}
