<?php

namespace Drupal\Tests\tone\Traits;

use Drupal\tone\Entity\ToneType;
use Drupal\tone\ToneTypeInterface;

/**
 * Provides common functionality for the Tone test classes.
 */
trait ToneTestTrait {

  /**
   * Creates a tone type.
   */
  public function createToneType(
    ?string $id = NULL,
    ?string $label = NULL,
    ?string $selector = NULL,
    ?string $identity = NULL,
    array $identityConfiguration = [],
    ?string $renderer = NULL,
    array $rendererConfiguration = [],
    ?string $attachmentStrategy = NULL,
    array $attachmentStrategyConfiguration = [],
  ): ToneTypeInterface {
    $bundle = ToneType::create([
      'id' => $id ?? $this->randomMachineName(),
      'label' => $label ?? $this->randomString(),
      'selector' => $selector ?? '&',
      'identity' => $identity ?? 'tone_entity_uuid',
      'identity_configuration' => $identityConfiguration,
      'renderer' => $renderer ?? 'tone_css_property',
      'renderer_configuration' => $rendererConfiguration,
      'attachment_strategy' => $attachmentStrategy ?? 'tone_css_public_files',
      'attachment_strategy_configuration' => $attachmentStrategyConfiguration,
    ]);
    $bundle->save();
    return $bundle;
  }

}
